## haxe 4.3.7

=== Makefile ===
# Haxe compiler Makefile
#
#  - use 'make' to build all
#  - use 'make haxe' to build only the compiler (not the libraries)
#  - if you want to build quickly, install 'ocamlopt.opt' and change OCAMLOPT=ocamlopt.opt
#
#  Windows users :
#  - use 'make -f Makefile.win' to build for Windows
#  - use 'make MSVC=1 -f Makefile.win' to build for Windows with OCaml/MSVC
#
.SUFFIXES : .ml .mli .cmo .cmi .cmx .mly

INSTALL_DIR=/usr/local
INSTALL_BIN_DIR=$(INSTALL_DIR)/bin
INSTALL_LIB_DIR=$(INSTALL_DIR)/lib/haxe
INSTALL_STD_DIR=$(INSTALL_DIR)/share/haxe/std
PACKAGE_OUT_DIR=out
INSTALLER_TMP_DIR=installer
PACKAGE_SRC_EXTENSION=.tar.gz

MAKEFILENAME?=Makefile
PLATFORM?=unix

DUNE_COMMAND=dune
HAXE_OUTPUT=haxe
HAXELIB_OUTPUT=haxelib
PREBUILD_OUTPUT=prebuild
EXTENSION=
LFLAGS=
STATICLINK?=0

SYSTEM_NAME=Unknown
ifeq ($(OS),Windows_NT)
	SYSTEM_NAME=Windows
else
	UNAME_S := $(shell uname -s)
	ifeq ($(UNAME_S),Linux)
		SYSTEM_NAME=Linux
	endif
	ifeq ($(UNAME_S),Darwin)
		SYSTEM_NAME=Mac
	endif
endif

# Configuration

ADD_REVISION?=0

BRANCH=$(shell git rev-parse --abbrev-ref HEAD)
COMMIT_SHA=$(shell git rev-parse --short HEAD)
COMMIT_DATE=$(shell \
	if [ "$$(uname)" = "Darwin" ]; then \
		date -u -r $$(git show -s --format=%ct HEAD) +%Y%m%d%H%M%S; \
	else \
		date -u -d @$$(git show -s --format=%ct HEAD) +%Y%m%d%H%M%S; \
	fi \
)
PACKAGE_FILE_NAME=haxe_$(COMMIT_DATE)_$(COMMIT_SHA)
HAXE_VERSION=$(shell $(CURDIR)/$(HAXE_OUTPUT) -version 2>&1 | awk '{print $$1;}')
HAXE_VERSION_SHORT=$(shell echo "$(HAXE_VERSION)" | grep -oE "^[0-9]+\.[0-9]+\.[0-9]+")

NEKO_VERSION=2.4.1
NEKO_MAJOR_VERSION=$(shell echo "$(NEKO_VERSION)" | grep -oE "^[0-9]+")
NEKO_VERSION_TAG=v$(shell echo "$(NEKO_VERSION)" | sed "s/\./-/g")

ifneq ($(STATICLINK),0)
	LIB_PARAMS= -cclib '-Wl,-Bstatic -lpcre2-8 -lz -lmbedtls -lmbedx509 -lmbedcrypto -Wl,-Bdynamic '
else
	LIB_PARAMS?= -cclib -lpcre2-8 -cclib -lz -cclib -lmbedtls -cclib -lmbedx509 -cclib -lmbedcrypto
endif
ifeq ($(SYSTEM_NAME),Mac)
	LIB_PARAMS+= -cclib '-framework Security -framework CoreFoundation'
endif

all: haxe tools

haxe:
	$(DUNE_COMMAND) build --workspace dune-workspace.dev src-prebuild/prebuild.exe
	_build/default/src-prebuild/prebuild.exe libparams $(LIB_PARAMS) > lib.sexp
	_build/default/src-prebuild/prebuild.exe version "$(ADD_REVISION)" "$(BRANCH)" "$(COMMIT_SHA)" > src/compiler/version.ml
	$(DUNE_COMMAND) build --workspace dune-workspace.dev src/haxe.exe
	cp -f _build/default/src/haxe.exe ./"$(HAXE_OUTPUT)"

plugin: haxe
	$(DUNE_COMMAND) build --workspace dune-workspace.dev plugins/$(PLUGIN)/$(PLUGIN).cmxs
	mkdir -p plugins/$(PLUGIN)/cmxs/$(SYSTEM_NAME)
	cp -f _build/default/plugins/$(PLUGIN)/$(PLUGIN).cmxs plugins/$(PLUGIN)/cmxs/$(SYSTEM_NAME)/plugin.cmxs

kill_exe_win:
ifdef SYSTEMROOT
	-@taskkill /F /IM haxe.exe 2>/dev/null
endif

# Only use if you have only changed gencpp.ml
quickcpp: build_src build_pass_4 copy_haxetoolkit

CPP_OS := $(shell uname)
ifeq ($(CPP_OS),Linux)
copy_haxetoolkit:
	sudo cp haxe /usr/bin/haxe
else
copy_haxetoolkit: /cygdrive/c/HaxeToolkit/haxe/haxe.exe
/cygdrive/c/HaxeToolkit/haxe/haxe.exe:haxe.exe
	cp $< $@
endif

ifeq ($(SYSTEM_NAME),Mac)
# This assumes that haxelib and neko will both be installed into INSTALL_DIR,
# which is the case when installing using the mac installer package
HAXELIB_LFLAGS= -Wl,-rpath,$(INSTALL_DIR)/lib
endif

haxelib_unix:
	cd $(CURDIR)/extra/haxelib_src && \
	HAXE_STD_PATH=$(CURDIR)/std $(CURDIR)/$(HAXE_OUTPUT) client.hxml && \
	nekotools boot -c run.n
	$(CC) $(CURDIR)/extra/haxelib_src/run.c -o $(HAXELIB_OUTPUT) -lneko $(HAXELIB_LFLAGS)

# haxelib should depends on haxe, but we don't want to do that...
ifeq ($(SYSTEM_NAME),Windows)
haxelib: haxelib_$(PLATFORM)
else
haxelib: haxelib_unix
endif

tools: haxelib

install: uninstall
	mkdir -p "$(DESTDIR)$(INSTALL_BIN_DIR)"
	cp $(HAXE_OUTPUT) $(HAXELIB_OUTPUT) "$(DESTDIR)$(INSTALL_BIN_DIR)"
	mkdir -p "$(DESTDIR)$(INSTALL_STD_DIR)"
	cp -r std/* "$(DESTDIR)$(INSTALL_STD_DIR)"

uninstall:
	rm -rf $(DESTDIR)$(INSTALL_BIN_DIR)/$(HAXE_OUTPUT) $(DESTDIR)$(INSTALL_BIN_DIR)/$(HAXELIB_OUTPUT)
	if [ -d "$(DESTDIR)$(INSTALL_LIB_DIR)/lib" ] && find "$(DESTDIR)$(INSTALL_LIB_DIR)/lib" -mindepth 1 -print -quit | grep -q .; then \
		echo "The local haxelib repo at $(DESTDIR)$(INSTALL_LIB_DIR)/lib will not be removed. Remove it manually if you want."; \
		find $(DESTDIR)$(INSTALL_LIB_DIR)/ ! -name 'lib' -mindepth 1 -maxdepth 1 -exec rm -rf {} +; \
	else \
		rm -rf $(DESTDIR)$(INSTALL_LIB_DIR); \
	fi
	rm -rf $(DESTDIR)$(INSTALL_STD_DIR)

opam_install:
	opam install camlp5 ocamlfind dune --yes

haxe_deps:
	opam pin add haxe . --no-action
	opam install haxe --deps-only --yes

# Package

package_env: opam_install haxe_deps

package_src:
	mkdir -p $(PACKAGE_OUT_DIR)
	# use git-archive-all since we have submodules
	# https://github.com/Kentzo/git-archive-all
	curl -s https://raw.githubusercontent.com/Kentzo/git-archive-all/1.15/git_archive_all.py -o extra/git_archive_all.py
	python extra/git_archive_all.py $(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_src$(PACKAGE_SRC_EXTENSION)

package_unix:
	mkdir -p $(PACKAGE_OUT_DIR)
	rm -rf $(PACKAGE_FILE_NAME) $(PACKAGE_FILE_NAME).tar.gz
	# Copy the package contents to $(PACKAGE_FILE_NAME)
	mkdir -p $(PACKAGE_FILE_NAME)
	cp -r $(HAXE_OUTPUT) $(HAXELIB_OUTPUT) std extra/LICENSE.txt extra/CONTRIB.txt extra/CHANGES.txt $(PACKAGE_FILE_NAME)
	# archive
	tar -zcf $(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_bin.tar.gz $(PACKAGE_FILE_NAME)
	rm -r $(PACKAGE_FILE_NAME)

package_bin: package_$(PLATFORM)

xmldoc:
	cd extra && \
	$(CURDIR)/$(HAXELIB_OUTPUT) newrepo && \
	$(CURDIR)/$(HAXELIB_OUTPUT) git hxcpp  https://github.com/HaxeFoundation/hxcpp   && \
	$(CURDIR)/$(HAXELIB_OUTPUT) git hxjava https://github.com/HaxeFoundation/hxjava  && \
	$(CURDIR)/$(HAXELIB_OUTPUT) git hxcs   https://github.com/HaxeFoundation/hxcs    && \
	PATH="$(CURDIR):$(PATH)" $(CURDIR)/$(HAXE_OUTPUT) doc.hxml

$(INSTALLER_TMP_DIR):
	mkdir -p $(INSTALLER_TMP_DIR)

# Can be 'universal', 'arm64', or 'x86_64'
ifndef PACKAGE_INSTALLER_MAC_ARCH
PACKAGE_INSTALLER_MAC_ARCH:=$(shell uname -m)
endif

$(INSTALLER_TMP_DIR)/neko-osx.tar.gz: $(INSTALLER_TMP_DIR)
	NEKO_ARCH_SUFFIX=$$(if [ "$(PACKAGE_INSTALLER_MAC_ARCH)" = "x86_64" ]; then \
		echo 64; \
	else \
		echo "-$(PACKAGE_INSTALLER_MAC_ARCH)"; \
	fi); \
	wget -nv https://github.com/HaxeFoundation/neko/releases/download/$(NEKO_VERSION_TAG)/neko-$(NEKO_VERSION)-osx$$NEKO_ARCH_SUFFIX.tar.gz -O installer/neko-osx.tar.gz

# Installer

package_installer_mac: $(INSTALLER_TMP_DIR)/neko-osx.tar.gz package_unix
	$(eval OUTFILE := $(shell pwd)/$(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_installer.tar.gz)
	$(eval PACKFILE := $(shell pwd)/$(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_bin.tar.gz)
	$(eval VERSION := $(shell $(CURDIR)/$(HAXE_OUTPUT) -version 2>&1))
	bash -c "rm -rf $(INSTALLER_TMP_DIR)/{resources,pkg,tgz,haxe.tar.gz}"
	mkdir $(INSTALLER_TMP_DIR)/resources
	# neko - unpack to change the dir name
	cd $(INSTALLER_TMP_DIR)/resources && tar -zxvf ../neko-osx.tar.gz
	mv $(INSTALLER_TMP_DIR)/resources/neko* $(INSTALLER_TMP_DIR)/resources/neko
	cd $(INSTALLER_TMP_DIR)/resources && tar -zcvf neko.tar.gz neko
	# haxe - unpack to change the dir name
	cd $(INSTALLER_TMP_DIR)/resources && tar -zxvf $(PACKFILE)
	mv $(INSTALLER_TMP_DIR)/resources/haxe* $(INSTALLER_TMP_DIR)/resources/haxe
	cd $(INSTALLER_TMP_DIR)/resources && tar -zcvf haxe.tar.gz haxe
	# scripts
	cp -rf extra/mac-installer/* $(INSTALLER_TMP_DIR)/resources
	sed -i '' 's/%%NEKO_VERSION%%/$(NEKO_VERSION)/g' $(INSTALLER_TMP_DIR)/resources/scripts/neko-postinstall.sh
	sed -i '' 's/%%NEKO_MAJOR_VERSION%%/$(NEKO_MAJOR_VERSION)/g' $(INSTALLER_TMP_DIR)/resources/scripts/neko-postinstall.sh
	cd $(INSTALLER_TMP_DIR)/resources && tar -zcvf scripts.tar.gz scripts
	# installer structure
	mkdir -p $(INSTALLER_TMP_DIR)/pkg
	cd $(INSTALLER_TMP_DIR)/pkg && xar -xf ../resources/installer-structure.pkg .
	mkdir $(INSTALLER_TMP_DIR)/tgz; mv $(INSTALLER_TMP_DIR)/resources/*.tar.gz $(INSTALLER_TMP_DIR)/tgz
	cd $(INSTALLER_TMP_DIR)/tgz; find . | cpio -o --format odc | gzip -c > ../pkg/files.pkg/Payload
	cd $(INSTALLER_TMP_DIR)/pkg/files.pkg && bash -c "INSTKB=$$(du -sk ../../tgz | awk '{print $$1;}'); \
	du -sk ../../tgz; \
	echo $$INSTKB ; \
	INSTKBH=`expr $$INSTKB - 4`; \
	echo $$INSTKBH ;\
	sed -i '' 's/%%INSTKB%%/$$INSTKBH/g' PackageInfo ;\
	sed -i '' 's/%%VERSION%%/$(VERSION)/g' PackageInfo ;\
	sed -i '' 's/%%VERSTRING%%/$(VERSION)/g' PackageInfo ;\
	sed -i '' 's/%%VERLONG%%/$(VERSION)/g' PackageInfo ;\
	sed -i '' 's/%%NEKOVER%%/$(NEKO_VERSION)/g' PackageInfo ;\
	cd .. ;\
	sed -i '' 's/%%VERSION%%/$(VERSION)/g' Distribution ;\
	sed -i '' 's/%%VERSTRING%%/$(VERSION)/g' Distribution ;\
	sed -i '' 's/%%VERLONG%%/$(VERSION)/g' Distribution ;\
	sed -i '' 's/%%NEKOVER%%/$(NEKO_VERSION)/g' Distribution ;\
	sed -i '' 's/%%INSTKB%%/$$INSTKBH/g' Distribution"
	# repackage
	cd $(INSTALLER_TMP_DIR)/pkg; xar --compression none -cf ../$(PACKAGE_FILE_NAME).pkg *
	# tar
	cd $(INSTALLER_TMP_DIR); tar -zcvf $(OUTFILE) $(PACKAGE_FILE_NAME).pkg

# Clean

clean: clean_haxe clean_tools clean_package

clean_haxe:
	rm -f -r _build $(HAXE_OUTPUT) $(PREBUILD_OUTPUT)

clean_tools:
	rm -f $(HAXE_OUTPUT) $(PREBUILD_OUTPUT) $(HAXELIB_OUTPUT)

clean_package:
	rm -rf $(PACKAGE_OUT_DIR)

FORCE:

# SUFFIXES

.ml.cmx:
	$(CC_CMD)

.ml.cmo:
	$(CC_CMD)

.PHONY: haxe haxelib

# our "all:" target doens't work in parallel mode
.NOTPARALLEL:

=== libs/Makefile ===
OCAMLOPT = ocamlopt
OCAMLC = ocamlc
TARGET_FLAG = all
LIBS=extlib-leftovers extc neko javalib ilib swflib ttflib objsize pcre2 ziplib

all: $(LIBS)
$(LIBS):
	$(MAKE) -C $@ OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)

clean:
	$(MAKE) -C extlib-leftovers clean
	$(MAKE) -C extc clean
	$(MAKE) -C neko clean
	$(MAKE) -C javalib clean
	$(MAKE) -C ilib clean
	$(MAKE) -C swflib clean
	$(MAKE) -C ttflib clean
	$(MAKE) -C objsize clean
	$(MAKE) -C pcre2 clean
	$(MAKE) -C ziplib clean

.PHONY: all clean $(LIBS)

Makefile: ;

=== extra/haxelib_src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

include(GNUInstallDirs)
project(Haxelib C)

# put output in ${CMAKE_BINARY_DIR}

set(OUTPUT_DIR ${CMAKE_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${OUTPUT_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${OUTPUT_DIR})

# avoid the extra "Debug", "Release" directories
# http://stackoverflow.com/questions/7747857/in-cmake-how-do-i-work-around-the-debug-and-release-directories-visual-studio-2
foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES} )
	string( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
	set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${OUTPUT_DIR} )
	set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${OUTPUT_DIR} )
	set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${OUTPUT_DIR} )
endforeach( OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES )

# find Haxe and Neko

find_program(HAXE_COMPILER haxe)

find_path(NEKO_INCLUDE_DIRS neko.h)
find_library(NEKO_LIBRARIES neko)
find_program(NEKO neko)
find_program(NEKOTOOLS nekotools)

message(STATUS "HAXE_COMPILER: ${HAXE_COMPILER}")
message(STATUS "NEKO_INCLUDE_DIRS: ${NEKO_INCLUDE_DIRS}")
message(STATUS "NEKO_LIBRARIES: ${NEKO_LIBRARIES}")
message(STATUS "NEKOTOOLS: ${NEKOTOOLS}")

include_directories(${NEKO_INCLUDE_DIRS})

add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/run.n
    COMMAND ${HAXE_COMPILER} client.hxml
    VERBATIM
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/run.c
    COMMAND ${NEKOTOOLS} boot -c run.n
    VERBATIM
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    DEPENDS ${CMAKE_SOURCE_DIR}/run.n
)

add_executable(haxelib
    ${CMAKE_SOURCE_DIR}/run.c
)

target_link_libraries(haxelib ${NEKO_LIBRARIES})

=== libs/extc/Makefile ===
ALL_CFLAGS = $(CFLAGS)
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC = extc.ml process.ml extc_stubs.c process_stubs.c

all: bytecode native

bytecode: extc.cma

native: extc.cmxa

extc.cma: extc_stubs.o process_stubs.o extc.ml process.ml
	ocamlfind $(OCAMLC) -safe-string -a -o extc.cma -package extlib extc.ml process.ml

extc.cmxa: extc.ml process.ml extc_stubs.o process_stubs.o
	ocamlfind $(OCAMLOPT) -safe-string -a -o extc.cmxa -package extlib extc.ml process.ml

extc_stubs.o: extc_stubs.c
	ocamlfind $(OCAMLC) -safe-string $(ALL_CFLAGS) extc_stubs.c

process_stubs.o: process_stubs.c
	ocamlfind $(OCAMLC) -safe-string $(ALL_CFLAGS) process_stubs.c

clean:
	rm -f extc.cma extc.cmi extc.cmx extc.cmxa extc.o extc.obj extc.lib extc_stubs.obj extc_stubs.o process.cmx process.obj process.cmi process.o process_stubs.obj process_stubs.o
	rm -f extc.a libextc.a libextc.lib extc.cmo process.cmo

.PHONY: all bytecode native clean
Makefile: ;
$(SRC): ;

=== libs/ilib/Makefile ===
OCAMLOPT=ocamlopt
OCAMLC=ocamlc

SRCS=peData.ml peReader.ml peWriter.ml ilMeta.mli ilData.mli ilMetaTools.ml ilMetaDebug.ml ilMetaReader.ml

all: native bytecode

native: ilib.cmxa
bytecode: ilib.cma

ilib.cmxa: $(SRCS)
	ocamlfind $(OCAMLOPT) -g -package extlib -safe-string -a -o ilib.cmxa $(SRCS)

ilib.cma: $(SRCS)
	ocamlfind $(OCAMLC) -g -package extlib -safe-string -a -o ilib.cma $(SRCS)

dump: ilib.cmxa dump.ml peDataDebug.ml ilMetaDebug.ml
	ocamlfind $(OCAMLOPT) -g -package extlib -safe-string -o dump ../extlib/extLib.cmxa ilib.cmxa peDataDebug.ml dump.ml

clean:
	rm -f ilib.cma ilib.cmxa ilib.lib ilib.a $(wildcard *.cmx) $(wildcard *.cmo) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi) dump

.PHONY: all bytecode native clean

Makefile: ;
$(SRCS): ;

=== libs/javalib/Makefile ===
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC=jData.ml jReader.ml jWriter.ml

all: bytecode native

native: javalib.cmxa
bytecode: javalib.cma

javalib.cmxa: $(SRC)
	ocamlfind $(OCAMLOPT) -g -package extlib -safe-string -a -o javalib.cmxa $(SRC)

javalib.cma: $(SRC)
	ocamlfind $(OCAMLC) -g -package extlib -safe-string -a -o javalib.cma $(SRC)

clean:
	rm -rf javalib.cmxa javalib.cma javalib.lib javalib.a $(wildcard *.cmx) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi) $(wildcard *.cmo)

.PHONY: all bytecode native clean

Makefile: ;
$(SRC): ;

=== libs/neko/Makefile ===
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC=nast.ml nxml.ml binast.ml nbytecode.ml ncompile.ml

all: bytecode native

native: neko.cmxa

bytecode: neko.cma

neko.cmxa: $(SRC)
	ocamlfind $(OCAMLOPT) -package extlib -safe-string -a -o neko.cmxa $(SRC)

neko.cma: $(SRC)
	ocamlfind $(OCAMLC) -package extlib -safe-string -a -o neko.cma $(SRC)

clean:
	rm -rf neko.cmxa neko.cma neko.lib neko.a $(wildcard *.cmx) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi) $(wildcard *.cmo)

.PHONY: all bytecode native clean

Makefile: ;
$(SRC): ;

=== libs/objsize/Makefile ===
ALL_CFLAGS = $(CFLAGS) -I .
LIBS =
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC=objsize.mli objsize.ml

all: bytecode native

bytecode: objsize.cma

native: objsize.cmxa

objsize.cma: c_objsize.o $(SRC)
	$(OCAMLC) -safe-string -a -o objsize.cma $(LIBS) $(SRC)

objsize.cmxa: c_objsize.o $(SRC)
	$(OCAMLOPT) -safe-string -a -o objsize.cmxa $(LIBS) $(SRC)

c_objsize.o: c_objsize.c
	$(OCAMLC) -safe-string $(ALL_CFLAGS) c_objsize.c

clean:
	rm -rf $(wildcard *.cma) $(wildcard *.cmxa) $(wildcard *.cmx) $(wildcard *.cmi) $(wildcard *.cmo) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.a)

.PHONY: all bytecode native clean

Makefile: ;
$(SRC): ;
c_objsize.c: ;

=== libs/pcre2/Makefile ===
ALL_CFLAGS = $(CFLAGS) -I pcre2
LIBS =
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC = pcre2.ml pcre2_stubs.c

all: bytecode native

bytecode: pcre2.cma

native: pcre2.cmxa

pcre2.cma: pcre2_stubs.o pcre2.ml
	$(OCAMLC) -safe-string -a -o pcre2.cma $(LIBS) pcre2.ml

pcre2.cmxa: pcre2.ml pcre2_stubs.o
	$(OCAMLOPT) -safe-string -a -o pcre2.cmxa $(LIBS) pcre2.ml

pcre2_stubs.o: pcre2_stubs.c
	$(OCAMLC) -safe-string $(ALL_CFLAGS) pcre2_stubs.c

clean:
	rm -f pcre2.cma pcre2.cmi pcre2.cmx pcre2.cmxa pcre2.o pcre2.obj pcre2_stubs.obj pcre2_stubs.o
	rm -f pcre2.a libpcre2-8.a libpcre2-8.lib pcre2.cmo

.PHONY: all bytecode native clean
Makefile: ;
$(SRC): ;

=== libs/swflib/Makefile ===
# Makefile generated by OCamake
# http://tech.motion-twin.com
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
.SUFFIXES : .ml .mli .cmo .cmi .cmx .mll .mly

ALL_CFLAGS= $(CFLAGS) -safe-string -package extlib -I ../extlib-leftovers -I ../extc -g
LIBS=

SRC=actionScript.ml as3hl.mli as3.mli png.ml swflib.sln swf.ml swfPic.ml as3code.ml as3hlparse.ml as3parse.ml png.mli swfParser.ml

MODULES=as3code.cmx png.cmx swf.cmx actionScript.cmx as3parse.cmx swfPic.cmx as3hlparse.cmx swfParser.cmx

all: native bytecode

native: swflib.cmxa

bytecode: swflib.cma

swflib.cmxa: $(MODULES)
	ocamlfind $(OCAMLOPT) -safe-string -o swflib.cmxa -a $(LIBS) $(MODULES)

swflib.cma: $(MODULES:.cmx=.cmo)
	ocamlfind $(OCAMLC) -safe-string -o swflib.cma -a $(LFLAGS) $(LIBS) $(MODULES:.cmx=.cmo)

actionScript.cmx: swf.cmx

actionScript.cmo: swf.cmi

as3code.cmo: as3.cmi

as3code.cmx: as3.cmi

as3hl.cmi: as3.cmi

as3hlparse.cmo: as3parse.cmo as3hl.cmi as3code.cmo as3.cmi

as3hlparse.cmx: as3parse.cmx as3hl.cmi as3code.cmx as3.cmi

as3parse.cmo: as3code.cmo as3.cmi

as3parse.cmx: as3code.cmx as3.cmi

png.cmo: png.cmi

png.cmx: png.cmi

swf.cmo: as3.cmi

swf.cmx: as3.cmi

swfParser.cmo: swf.cmo as3parse.cmo actionScript.cmo

swfParser.cmx: swf.cmx as3parse.cmx actionScript.cmx

swfPic.cmx: swf.cmx png.cmi

clean:
	rm -f swflib.cmxa swflib.cma swflib.lib swflib.a as3.cmi as3hl.cmi
	rm -f $(MODULES) $(MODULES:.cmx=.obj) $(MODULES:.cmx=.cmi) $(MODULES:.cmx=.o) $(MODULES:.cmx=.cmo)

# SUFFIXES
.ml.cmo:
	ocamlfind $(OCAMLC) $(ALL_CFLAGS) -c $<

.ml.cmx:
	ocamlfind $(OCAMLOPT) $(ALL_CFLAGS) -c $<

.mli.cmi:
	ocamlfind $(OCAMLC) $(ALL_CFLAGS) $<

.mll.ml:
	ocamlfind ocamllex $<

.mly.ml:
	ocamlfind ocamlyacc $<

.PHONY: all bytecode native clean

Makefile: ;
$(SRC): ;

=== libs/ziplib/Makefile ===
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC=zlib.mli zlib.ml zip.mli zip.ml

all: native bytecode

native: ziplib.cmxa
ziplib.cmxa: $(SRC)
	ocamlfind $(OCAMLOPT) -safe-string -g -I ../extlib -I ../extc -a -o ziplib.cmxa $(SRC)

bytecode: ziplib.cma
ziplib.cma: $(SRC)
	ocamlfind $(OCAMLC) -safe-string -g -I ../extlib -I ../extc -a -o ziplib.cma $(SRC)

clean:
	rm -rf ziplib.cmxa ziplib.cma ziplib.lib ziplib.a $(wildcard *.cmx) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi) $(wildcard *.cmo)

.PHONY: all native bytecode clean

Makefile: ;

$(SRC): ;

=== libs/ziplib/test/Makefile ===
OCAMLOPT=ocamlopt

all: ../zip.cmxa minizip.ml
	$(OCAMLOPT) -g -g -I .. -I ../../extc -o minizip -cclib ../../extc/extc_stubs.o -cclib -lz unix.cmxa ../zip.cmxa minizip.ml

clean:
	rm -rf minizip $(wildcard *.cmx) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi)

=== debian/changelog ===
haxe (1:4.3.7-1) unstable; urgency=medium

  * New upstream version.
  * Remove ocaml5.3.patch and mbedtls3.patch, which were integrated in this
    version already.
  * Bump Standards-Version to 4.7.2 (no changes).

 -- Andy Li <andy@onthewings.net>  Sat, 06 Sep 2025 05:18:22 +0000

=== debian/control ===
Source: haxe
Section: devel
Priority: optional
Maintainer: Andy Li <andy@onthewings.net>
Standards-Version: 4.7.2
Build-Depends: debhelper (>= 10),
               dh-ocaml,
               ocaml-nox,
               ocaml-findlib,
               ocaml-dune (>= 3),
               camlp5,
               libxml-light-ocaml-dev,
               libsedlex-ocaml-dev (>= 2.0),
               libextlib-ocaml-dev,
               libptmap-ocaml-dev,
               libsha-ocaml-dev,
               libluv-ocaml-dev (>= 0.5.12),
               libuv1-dev,
               libmbedtls-dev,
               neko (>= 2.3.0),
               neko-dev (>= 2.3.0),
               zlib1g-dev,
               libpcre2-dev,
               bash-completion
Vcs-Git: https://github.com/HaxeFoundation/haxe-debian.git
Vcs-Browser: https://github.com/HaxeFoundation/haxe-debian
Homepage: https://haxe.org

Package: haxe
Architecture: any
Depends: neko (>= 2.0.0),
         ${misc:Depends},
         ${ocaml:Depends},
         ${shlibs:Depends}
Description: multi-target universal programming language
 Haxe is an open source toolkit based on a modern,
 high level, strictly typed programming language, a cross-compiler,
 a complete cross-platform standard library and ways to access each
 platform's native capabilities.

=== debian/watch ===
version=4
opts="uversionmangle=s/-/~/g" \
 https://github.com/HaxeFoundation/haxe/tags .*/archive/refs/tags/(\d\S*)\.tar\.gz

## haxe 20060912

=== haxe/Makefile ===
# Makefile generated by OCamake 
# http://tech.motion-twin.com
.SUFFIXES : .ml .mli .cmo .cmi .cmx .mll .mly

CFLAGS= -I ../neko/libs/include/ocaml
LIBS=extLib.cmxa extc.cmxa swfLib.cmxa unix.cmxa
LFLAGS= -o haxe.exe -I ../neko/libs/include/ocaml
OUTPUT=sed 's/File "\([^"]\+\)", line \([0-9]\+\), \(.*\)/\1(\2): \3/' tmp.cmi

all: haxe.exe

haxe.exe: ../neko/libs/include/ocaml/nast.cmx ast.cmx plugin.cmx ../neko/libs/include/ocaml/nxml.cmx lexer.cmx type.cmx genswf9.cmx parser.cmx transform.cmx typer.cmx genneko.cmx genjs.cmx genswf.cmx genxml.cmx main.cmx
	ocamlopt $(LFLAGS) $(LIBS) ../neko/libs/include/ocaml/nast.cmx ast.cmx plugin.cmx ../neko/libs/include/ocaml/nxml.cmx lexer.cmx type.cmx parser.cmx transform.cmx typer.cmx genneko.cmx genjs.cmx genswf9.cmx genswf.cmx genxml.cmx main.cmx

genneko.cmx: typer.cmx type.cmx plugin.cmx ../neko/libs/include/ocaml/nxml.cmx ../neko/libs/include/ocaml/nast.cmx lexer.cmx ast.cmx

../neko/libs/include/ocaml/nxml.cmx: ../neko/libs/include/ocaml/nast.cmx

genjs.cmx: typer.cmx type.cmx transform.cmx ast.cmx

genswf.cmx: typer.cmx type.cmx transform.cmx plugin.cmx genswf9.cmx ast.cmx

genswf9.cmx: type.cmx ast.cmx typer.cmx transform.cmx

genxml.cmx: typer.cmx type.cmx lexer.cmx ast.cmx

lexer.cmx: lexer.ml

lexer.cmx: ast.cmx

main.cmx: typer.cmx plugin.cmx parser.cmx lexer.cmx genxml.cmx genswf.cmx genneko.cmx genjs.cmx ast.cmx

parser.cmx: parser.ml plugin.cmx lexer.cmx ast.cmx
	(ocamlopt -pp camlp4o $(CFLAGS) -c parser.ml 2>tmp.cmi && $(OUTPUT)) || ($(OUTPUT) && exit 1)

transform.cmx: type.cmx

type.cmx: ast.cmx

typer.cmx: type.cmx plugin.cmx parser.cmx lexer.cmx ast.cmx

clean:
	rm -f haxe.exe
	rm -f typer.obj typer.cmx typer.cmi type.obj type.cmx type.cmi transform.obj transform.cmx transform.cmi plugin.obj plugin.cmx plugin.cmi parser.obj parser.cmx parser.cmi main.obj main.cmx main.cmi lexer.obj lexer.cmx lexer.cmi lexer.ml genxml.obj genxml.cmx genxml.cmi genswf9.obj genswf9.cmx genswf9.cmi genswf.obj genswf.cmx genswf.cmi genjs.obj genjs.cmx genjs.cmi ast.obj ast.cmx ast.cmi ../neko/libs/include/ocaml/nxml.obj ../neko/libs/include/ocaml/nxml.cmx ../neko/libs/include/ocaml/nxml.cmi ../neko/libs/include/ocaml/nast.obj ../neko/libs/include/ocaml/nast.cmx ../neko/libs/include/ocaml/nast.cmi genneko.obj genneko.cmx genneko.cmi

# SUFFIXES
.ml.cmo:
	ocamlc $(CFLAGS) -c $<

.ml.cmx:
	(ocamlopt $(CFLAGS) -c $< 2>tmp.cmi && $(OUTPUT)) || ($(OUTPUT) && exit 1)

.mli.cmi:
	ocamlc $(CFLAGS) $<

.mll.ml:
	ocamllex $<

.mly.ml:
	ocamlyacc $<
